<?php
// $Id: elementdefaults.admin.inc,v 1.1.2.1 2009/12/16 14:36:10 ershovandrey Exp $
/**
 * @file
 * Form for module settings page
 */
function elementdefaults_admin_settings_form(&$form_state) {
  $form['page_vis_settings'] = array(
    '#type' => 'fieldset',
    '#title' => t('Page specific visibility settings'),
    '#collapsible' => TRUE,
  );
  $form['page_vis_settings']['elementdefaults_visibility_mode'] = array(
    '#type' => 'radios',
    '#title' => t("Form elements initialization on specific pages"),
    '#options' => array(t('Enable on every page except the listed pages.'),
                        t('Enable on only the listed pages.'),
                        t('Enable if the following PHP code returns <code>TRUE</code> (PHP-mode, experts only).')),
    '#default_value' => variable_get('elementdefaults_visibility_mode', 0),
  );
  $form['page_vis_settings']['elementdefaults_visibility_pages'] = array(
    '#type' => 'textarea',
    '#title' => t('Pages'),
    '#default_value' => variable_get('elementdefaults_visibility_pages', ''),
    '#description' => t("Enter one page per line as Drupal paths. The '*' character is a wildcard. Example paths are %blog for the blog page and %blog-wildcard for every personal blog. %front is the front page.", array('%blog' => 'blog', '%blog-wildcard' => 'blog/*', '%front' => '<front>')) .' '. t('If the PHP-mode is chosen, enter PHP code between %php. Note that executing incorrect PHP-code can break your Drupal site.', array('%php' => '<?php ?>')),
  );
  return system_settings_form($form);
}