<?php
// $Id: elementdefaults.inc,v 1.1.2.1 2009/12/16 14:36:10 ershovandrey Exp $
/**
 * @file
 * Main engine of the module
 */

function elementdefaults_set_value(&$element, $request, $form) {
  $children = array();
  $children = element_children($element);
  if (isset($children[0]) && $children[0]===0) {
    return;
  }
  foreach ($children as $pos => $form_element) {
    if (isset($element[$children[$pos]]['#type'])) $type = $element[$children[$pos]]['#type'];
    else $type = '';
    if (($type !== "value") && ($type !== "token") && ($type !== "submit")/* && ($type !== "fieldset")*/ && ($type !== "weight")) {
      if (isset($request[$form_element])) {
        $value = explode('^', $request[$form_element]);
        $vals = explode("||", $value[0]);
        $mode = $value[1];
        switch ($type) {
          case "date": {
            if (isset($element[$children[$pos]]['#webform_component'])) {
              $element[$children[$pos]]['#webform_component']['value']= $vals[0];
            }
            break;
          }
          case "checkboxes":
          case "select": {
            if ($element[$children[$pos]]['#multiple'] || ($type==="checkboxes")) {
              $element[$children[$pos]]['#default_value'] = array();
              foreach ($vals as $vkey => $val) {
                $element[$children[$pos]]['#default_value'][$vkey] = $vals[$vkey];
              }
            }
            else {
              $element[$children[$pos]]['#default_value'] = $vals[0];
            }
            break;
          }
          case "nodereference_select":
          case "userreference_select":
          case "nodereference_buttons":
          case "userreference_buttons":
          case "optionwidgets_select":
          case "optionwidgets_buttons": {
            if (($type=="userreference_buttons") || ($type=="userreference_select")) $tp='uid';
            elseif (($type=="nodereference_buttons") || ($type=="nodereference_select")) $tp='nid';
            else $tp='value';
            foreach ($element[$children[$pos]]['#default_value'] as $k => $chld) { //delete old values
              $element[$children[$pos]]['#default_value'][$k] = '';
            }
            foreach ($vals as $vkey => $val) {
              if (isset($element[$children[$pos]]['#default_value'][$vkey])) {
                $element[$children[$pos]]['#default_value'][$vkey][$tp] = $val;
              }
            }
            break;
          }
          case "optionwidgets_onoff": {
            $element[$children[$pos]]['#default_value'][0]['value'] = $vals[0];
            break;
          }
          default: {
            if (isset($element[$children[$pos]][0])) {
              foreach ($vals as $vkey => $val) {
                if (isset($element[$children[$pos]][$vkey])) {
                  if (isset($element[$children[$pos]][$vkey]['#type'])) {
                    $type=$element[$children[$pos]][$vkey]['#type'];
                    if ($type=='userreference_autocomplete') $tp='uid';
                    elseif ($type=='nodereference_autocomplete') $tp='nid';
                    elseif ($type=='email_textfield') $tp='email';
                    else $tp='value';
                    if (count(element_children($element[$children[$pos]]))>1) {
                      //foreach ($vals as $key => $val) {
                        $element[$children[$pos]][$vkey]['#default_value'][$tp] = $val;
                      //}
                    }
                    else {
                      $element[$children[$pos]][0]['#default_value'][$tp] = $vals[0];
                    }
                  }
                  else {
                    $element[$children[$pos]][$vkey]['#default_value']['value'] = $val;
                  }
                }
              }
            }
            else {
              $element[$children[$pos]]['#default_value'] = $vals[0];
            }
          }
        }
        if (isset($mode) && ($mode!=='')) {
          elementdefaults_set_mode($element, $children, $pos, $mode, $type, $form);
        }
      }
    }
    elementdefaults_set_value($element[$children[$pos]], $request, $form);
  }
}

function elementdefaults_set_mode(&$element, $children, $pos, $mode, $type, $form) {
  switch ($mode) {
    case '0': {//hide
      $element[$children[$pos]]['#prefix']="<div class='elementdefaults-hidden' style='display: none'>". $element[$children[$pos]]['#prefix'];
      $element[$children[$pos]]['#suffix']=$element[$children[$pos]]['#suffix'] ."</div>";
      break;
    }
    case '1': {//conver to markup
      $markup=elementdefaults_to_markup($element, $children, $pos, $type, $form);
      $element[$children[$pos]]['#prefix']="<div class='elementdefaults-hidden' style='display: none'>" . $element[$children[$pos]]['#prefix'];
      $element[$children[$pos]]['#suffix']=$element[$children[$pos]]['#suffix'] ."</div>";
      $element[$children[$pos]]['#suffix'] .="<div class='elementdefaults-markup form-item'>". $markup['label'] . $markup['value'] ."</div>";
      break;
    }
    case '2': {//disable
      switch ($type) {
        case "date":
        case "checkboxes":
        case 'number':
        case 'date_combo':
        case 'text_textarea':
        case 'text_textfield':
        case 'email_textfield':
        case "nodereference_select":
        case "userreference_select":
        case "nodereference_buttons":
        case "userreference_buttons":
        case "optionwidgets_select":
        case "optionwidgets_buttons":
        case "optionwidgets_onoff":
        case "userreference_autocomplete":
        case "nodereference_autocomplete": {
          break;
        }
        default: {
          $disabled=elementdefaults_to_disabled($element, $children, $pos, $type, $form);
          $element[$children[$pos]]['#prefix']="<div class='elementdefaults-hidden' style='display: none'>". $element[$children[$pos]]['#prefix'];
          $element[$children[$pos]]['#suffix']=$element[$children[$pos]]['#suffix'] ."</div>";
          $element[$children[$pos]]['#suffix'] .=$disabled;
        }
      }
      break;
    }
  }
}

function elementdefaults_to_markup(&$element, $children, $pos, $type, $form) {
  $markup=array();
  $label='';
  $value='';
  if (isset($element[$children[$pos]]['#title'])) {
    $label="<label class='elementdefaults-label'>". $element[$children[$pos]]['#title'] .":&nbsp;</label>";
  }
  switch ($type) {
    case 'date': {
      $value = $element[$children[$pos]]['#webform_component']['value'];
      break;
    }
    case 'number':
    case 'date_combo':
    case 'text_textarea':
    case 'text_textfield':
    case 'email_textfield':
    case 'userreference_autocomplete':
    case 'nodereference_autocomplete': {
      if ($type==='userreference_autocomplete') $tp='uid';
      elseif ($type==='nodereference_autocomplete') $tp='nid';
      elseif ($type=='email_textfield') $tp='email';
      else $tp='value';
      $child=element_children($element[$children[$pos]]);
      $val=array();
      if (($type==='userreference_autocomplete') || ($type==='nodereference_autocomplete')) {
        $options=optionwidgets_options($form['#field_info'][$element[$children[$pos]]['#field_name']]);
        foreach ($child as $elem) {
          if ($element[$children[$pos]][$elem]['#default_value'][$tp]!='') $val[]=$options[$element[$children[$pos]][$elem]['#default_value'][$tp]];
        }
      }
      else {
        foreach ($child as $elem) {
          if ($element[$children[$pos]][$elem]['#default_value'][$tp]!='') $val[]=$element[$children[$pos]][$elem]['#default_value'][$tp];
        }
      }
      $value=implode(', ', $val);
      break;
    }
    case 'userreference_select':
    case 'userreference_buttons':
    case 'nodereference_select':
    case 'nodereference_buttons':
    case 'optionwidgets_select':
    case 'optionwidgets_buttons': {
      if (($type==='userreference_select') || ($type==='userreference_buttons')) $tp='uid';
      elseif (($type==='nodereference_select') || ($type==='nodereference_buttons')) $tp='nid';
      else $tp='value';
      $child=element_children($element[$children[$pos]]['#default_value']);
      $val=array();
      $options=optionwidgets_options($form['#field_info'][$element[$children[$pos]]['#field_name']]);
      foreach ($child as $elem) {
        if ($element[$children[$pos]]['#default_value'][$elem][$tp]!='') $val[]=$options[$element[$children[$pos]]['#default_value'][$elem][$tp]];
      }
      $value=implode(', ', $val);
      break;
    }
    case 'optionwidgets_onoff': {
      $options=optionwidgets_options($form['#field_info'][$element[$children[$pos]]['#field_name']]);
      if ($element[$children[$pos]]['#default_value'][0]['value']!='') $value=$options[$element[$children[$pos]]['#default_value'][0]['value']];
      break;
    }
    case "checkboxes":
    case 'select': {
      $vals=array();
      if ($element[$children[$pos]]['#multiple']) {
        if (is_array($element[$children[$pos]]['#default_value'])) {
          foreach ($element[$children[$pos]]['#default_value'] as $val) {
            $vals[]=$element[$children[$pos]]['#options'][$val];
          }
        }
        else $vals=$element[$children[$pos]]['#options'][$element[$children[$pos]]['#default_value']];
        $value=implode(', ', $vals);
      }
      else {
        $value=$element[$children[$pos]]['#options'][$element[$children[$pos]]['#default_value']];
      }
      break;
    }
    default: {
      if ($element[$children[$pos]]['#multiple']) {
        $value=implode(', ', $element[$children[$pos]]['#default_value']);
      }
      else {
        $value=$element[$children[$pos]]['#default_value'];
      }
    }
  }
  $markup["label"]=$label;
  $markup["value"]=$value;
  return $markup;
}

function elementdefaults_to_disabled(&$element, $children, $pos, $type, $form) {
  $element[$children[$pos] ."_disabled"]=$element[$children[$pos]];
  $element[$children[$pos] ."_disabled"]['#value'] = $element[$children[$pos]]['#default_value'];
  $element[$children[$pos] ."_disabled"]['#attributes']['disabled']='disabled';
  $disabled=drupal_render($element[$children[$pos] ."_disabled"]);
  return $disabled;
}